<template>
  <div>
    <div v-for="product in products" :key="product.id">
      <p style="font-weight: bold;">{{ product.title }}</p>
      <p>Цена: {{ product.price }}</p>
      <router-link :to="{ name: 'product', params: { id: product.id }}">Подробнее</router-link>
      <br/>
      <button @click="buy(product)" :disabled="inCart(product)">Купить</button>
    </div>
  </div>
</template>

<script>
export default {
  name: 'Catalog',
  data() {
    return {
      products: [],
    }
  },
  created() {
    this.fetchProducts()
  },
  methods: {
    async fetchProducts() {
      const response = await fetch('http://localhost:3000/products')
      this.products = await response.json()
    },
    buy(product) {
      this.$store.dispatch('cartModule/actualBuy', product)
    },
    inCart(product) {
      return !!this.$store.state.cartModule.cart.find(p => p.id === product.id)
    }
  }
}
</script>
